// atome.cpp

#include "atome.h"

#include "molecule.h"
#include "liste.h"

#include <iostream.h>
#include <string.h>

Liste * Atome::mesInstances = NULL;

Atome::Atome(char * n) : Entite (n) {
  maMolecule = NULL;
  mesInstances->ajouter(this);
}

Atome::~Atome() {
  mesInstances->enlever(this);
}
  
char * Atome::toString() { 
  char * s = new char[128];
  strcat(s, toNom());
  strcat(s, toMolecule());
  return s; 
}

char * Atome::toMolecule() {
  char * s = new char[64];
  strcat(s, " ma molecule: ");
  // Question 1: 'Atome.toMolecule'
  // KO:
  // strcat(s, maMolecule->toNom());
  // strcat(s, " ");
  // OK:
  if (maMolecule==NULL) strcat(s, "null ");
  else {
    strcat(s, maMolecule->toNom());
    strcat(s, " ");
  }
  return s;
}

void Atome::boucle() { 
  while (menu()!='P'); 
}

char Atome::menu() {
  cout << "Atome :" << endl;
  cout << "\t C. Creation" << endl;
  cout << "\t D. Destruction" << endl;
  cout << "\t A. Affichage" << endl;
  cout << "\t P. Precedent" << endl;
  char r; cin >> r;
  switch(r) {
  case 'C': creation(); break;
  case 'D': destruction(); break;
  case 'A': {
    cout << "Les atomes sont: " << endl; 
    cout << mesInstances->toString(); 
    } break;
  }
  return r;
}

void Atome::creation() {
  cout << "Creation d'un atome: " << endl; 
  cout << "Nom de l'atome ? "; 
  char s[32]; cin >> s;
  Atome * a = new Atome(s);
  cout << endl << "Atome '" << s << "' cree." << endl; 
}

void Atome::destruction() {
  cout << "Destruction d'un atome: " << endl; 
  cout << "Nom de l'atome ? "; 
  char s[32]; cin >> s;
  Atome * a = (Atome*) mesInstances->getInstance(s);
  if (a!=NULL) {
    // Question 2: 'Atome.destruction'
    // KO: rien
    // OK: cette ligne:
    if (a->maMolecule!=NULL) a->maMolecule->mesAtomes->enlever(a);
    delete a;
    cout << endl << "Atome '" << s << "' detruit." << endl;
  }
  else cout << endl << "Pas d'atome portant le nom '" << s << "'." << endl;
}

// question 'Molecule.destruction'
// KO: rien
// OK: cette fonction:
void Atome::dereferencer(Liste * la) {
  Atome * a = (Atome *) la->premier();
  if (a!=NULL) a->maMolecule = NULL;
  else return;
  for ( ;; ) {
    a = (Atome *) la->prochain();
    if (a!=NULL) a->maMolecule = NULL;
    else return;
  }
}

