// liste.cpp

#include "liste.h"
#include "entite.h"

#include <iostream.h>
#include <string.h>

/////////////////////////////////////////////////////////////////////////
element::element() { suivant = NULL; contenu = NULL; }

/////////////////////////////////////////////////////////////////////////
element::~element() { }

////////////////////////////////////////////////////////////////////////
Liste::Liste()
{
  debut = NULL;
  courant = debut;
  longueur = 0;
}

////////////////////////////////////////////////////////////////////////
Liste::~Liste()
{
  element * suiv;
  courant = debut;
  while (courant) {
      suiv = courant->suivant;
      delete courant;
      courant = suiv;
  }
}

////////////////////////////////////////////////////////////////////////
void Liste::ajouter(Entite * chose )
{ 
  element * adel = new element();
  adel->suivant = debut;
  adel->contenu = chose;
  debut = adel;
  longueur++;
}



/////////////////////////////////////////////////////////////////////////
int Liste::enlever(Entite * chose )
{
  element * pendant = debut;
  if (pendant==NULL) return -1;
  element * avant = NULL;
  while (pendant->contenu!=chose) {
    avant = pendant;
    pendant = pendant->suivant;
    if (pendant==NULL) return -1;
  }
  if (pendant==debut) debut = pendant->suivant;
  else avant->suivant = pendant->suivant;
  delete pendant;
  longueur--;
  return 0;
}




////////////////////////////////////////////////////////////////////////
Entite * Liste::premier()
{
  courant = debut;
  if (courant) return courant->contenu;
  else return NULL;
}

////////////////////////////////////////////////////////////////////////
Entite * Liste::prochain()
{
  if (courant) {
    courant=courant->suivant;
    if (courant) return courant->contenu;
    else return NULL;
  }
  else return NULL;
}


/////////////////////////////////////////////////////////////////////////
Entite * Liste::getInstance(char * chose )
{
  element * pendant = debut;
  if (pendant==NULL) return NULL;
  while (strcmp(pendant->contenu->nom,chose)) {
    pendant = pendant->suivant;
    if (pendant==NULL) return NULL;
    courant = pendant;
  }
  return pendant->contenu;
}


////////////////////////////////////////////////////////////////////////
char * Liste::toString()
{
  char * s = new char[1024];
  Entite * ptr = (Entite *) premier();
  if (ptr!=NULL) {
    strcat(s, ptr->toString());
    strcat(s, "\n");
    // cout << "Liste::toString: s = <" << s << ">" << endl;
  }
  else return s;
  for ( ;; ) {
    ptr = (Entite *) prochain();
    if (ptr!=NULL) {
      strcat(s, ptr->toString());
      strcat(s, "\n");
      // cout << "Liste::toString: s = <" << s << ">" << endl;
    }
    else return s;
  }
}

////////////////////////////////////////////////////////////////////////
char * Liste::toNom()
{
  char * s = new char[1024];
  Entite * ptr = (Entite *) premier();
  if (ptr!=NULL) {
    strcat(s, ptr->toNom());
    strcat(s, " ");
    // cout << "Liste::toNom: s = <" << s << ">" << endl;
  }
  else return s;
  for ( ;; ) {
    ptr = (Entite *) prochain();
    if (ptr!=NULL) {
      strcat(s, ptr->toNom());
      strcat(s, " ");
      // cout << "Liste::toNom: s = <" << s << ">" << endl;
    }
    else return s;
  }
}



