// molecule.cpp

#include "molecule.h"

#include "atome.h"
#include "liste.h"

#include <iostream.h>
#include <string.h>

Liste * Molecule::mesInstances;

Molecule::Molecule(char * n) : Entite(n) {
  mesAtomes = new Liste();
  mesInstances->ajouter(this);
}

Molecule::~Molecule() { 
  mesInstances->enlever(this); 
  delete mesAtomes;
}

char * Molecule::toString() { 
  char * s = new char[1024];
  strcat(s, toNom());
  strcat(s, " Mes atomes: ");
  strcat(s, mesAtomes->toNom());
  return s; 
}

void Molecule::boucle() { 
  while (menu()!='P'); 
}

char Molecule::menu() {
  cout << "Molecule :" << endl;
  cout << "\t C. Creation" << endl;
  cout << "\t J. aJouter un atome" << endl;
  cout << "\t R. Retirer un atome" << endl;
  cout << "\t D. Destruction" << endl;
  cout << "\t A. Affichage" << endl;
  cout << "\t P. Precedent" << endl;
  char r; cin >> r;
  switch(r) {
  case 'C': creation(); break;
  case 'J': ajoutAtome(); break;
  case 'R': retraitAtome(); break;
  case 'D': destruction(); break;
  case 'A': {
    cout << "Les molecules sont: " << endl; 
    cout << mesInstances->toString(); 
  } break;
  } 
  return r;
}

void Molecule::creation() {
  cout << "Creation d'une molecule: " << endl; 
  cout << "Nom de la molecule ? "; 
  char s[32]; cin >> s;
  Molecule * m = new Molecule(s);
  cout << endl << "Molecule '" << s << "' creee." << endl; 
}

void Molecule::destruction() {
  cout << "Destruction d'une molecule: " << endl; 
  cout << "Nom de la molecule ? "; 
  char s[32]; cin >> s;
  Molecule * m = (Molecule*) mesInstances->getInstance(s);
  if (m!=NULL) {
    // Question 3: 'Molecule.destruction' 
    // OK:
    Atome::dereferencer(m->mesAtomes);
    // KO: rien
    delete m;
    cout << endl << "Molecule '" << s << "' detruite." << endl;
  }
  else cout << endl << "Pas de molecule avec le nom '" << s << "'." << endl;
}

void Molecule::ajoutAtome() {
  cout << "Ajout d'un atome a une molecule: " << endl; 
  cout << "Nom de la molecule ? "; 
  char sm[32]; cin >> sm;
  Molecule * m = (Molecule*) mesInstances->getInstance(sm);
  if (m==NULL) {
    cout << endl << "Pas de molecule avec le nom '" << sm << "'." << endl;
    return;
  }

  cout << endl << "Nom de l'atome ? "; 
  char sa[32]; cin >> sa;
  Atome * a = (Atome*) Atome::mesInstances->getInstance(sa);
  if (a==NULL) {
    cout << endl << "Pas d'atome avec le nom '" << sa << "'." << endl;
    return;
  }
  // Question 4: 'Molecule.AjoutAtome' 
  // OK:
  if (a->maMolecule!=NULL) {
    cout << endl << "L'atome '" << sa << "' appartient deja a la molecule '" 
	 << a->maMolecule->toNom() << "'." << endl;
    return;
  } 
  // KO: rien
  m->mesAtomes->ajouter(a);
  a->maMolecule = m;
  cout << endl << "Atome '" << sa << "' ajoute a la molecule '" 
       << sm << "'." << endl;
}

void Molecule::retraitAtome() {
  cout << "Retrait d'un atome d'une molecule: \n"; 
  cout << endl << "Nom de la molecule ? "; 
  char sm[32]; cin >> sm;
  Molecule * m = (Molecule*) mesInstances->getInstance(sm);
  if (m==NULL) {
    cout << endl << "Pas de molecule avec le nom '" << sm << "'.";
    return;
  }

  cout << endl << "Nom de l'atome ? "; 
  char sa[32]; cin >> sa;
  // Question 5: 'Molecule.RetraitAtome'
  // KO:
  // Atome * a = (Atome*) Atome::mesInstances->getInstance(sa);
  // OK:
  Atome * a = (Atome*) m->mesAtomes->getInstance(sa);
  if (a==NULL) {
    cout << endl << "Pas d'atome avec le nom '" << sa << "'.\n";
    return;
  }
  m->mesAtomes->enlever(a);
  a->maMolecule = NULL;
  cout << endl << "Atome '" << sa << "' retire de la molecule '" 
       << sm << "'." << endl;
}

